# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2017 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2017, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from nfe.pysped.xml_sped import *
from nfe.nfe_400.manual_600 import nfe_400


class InfNFeSupl(XMLNFe):
    def __init__(self):
        super(InfNFeSupl, self).__init__()
        self.qrCode = TagCaracter(nome=u'qrCode', codigo=u'ZX02', tamanho=[100, 600],
                                  raiz=u'//NFe/infNFeSupl')
        self.urlChave = TagCaracter(nome=u'urlChave', codigo=u'ZX03', tamanho=[21, 85],
                                    raiz=u'//NFe/infNFeSupl')

    @property
    def xml(self):
        if not self.qrCode.valor:
            return u''
        xml = XMLNFe.get_xml(self)
        xml += u'<infNFeSupl>'
        xml += self.qrCode.xml
        xml += self.urlChave.xml
        xml += u'</infNFeSupl>'

        return xml

    @xml.setter
    def xml(self, arquivo):
        if self._le_xml(arquivo):
            self.qrCode.xml = arquivo
            self.urlChave.xml = arquivo


class NFCe(nfe_400.NFe):
    def __init__(self):
        super(NFCe, self).__init__()
        self.namespace = NAMESPACE_NFE
        self.infNFeSupl = InfNFeSupl()

    @property
    def xml(self):
        xml = ABERTURA
        xml += u'<NFe xmlns="http://www.portalfiscal.inf.br/nfe">'
        xml += self.infNFe.xml
        xml += self.infNFeSupl.xml
        self.Signature.URI = u'#' + self.infNFe.Id.valor
        xml += self.Signature.xml
        xml += u'</NFe>'

        return xml

    @xml.setter
    def xml(self, arquivo):
        if self._le_xml(arquivo):
            self.infNFe.xml = arquivo
            self.infNFeSupl.xml = arquivo
            self.Signature.xml = self._le_noh(u'//NFe/sig:Signature')

    def monta_chave(self):
        self.gera_nova_chave()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
